// This is mutant program.
// Author : ysma

package org.joda.time;


import org.joda.time.base.BaseSingleFieldPeriod;
import org.joda.time.field.FieldUtils;
import org.joda.time.format.ISOPeriodFormat;
import org.joda.time.format.PeriodFormatter;


public final class Minutes extends org.joda.time.base.BaseSingleFieldPeriod
{

    public static final org.joda.time.Minutes ZERO = new org.joda.time.Minutes( 0 );

    public static final org.joda.time.Minutes ONE = new org.joda.time.Minutes( 1 );

    public static final org.joda.time.Minutes TWO = new org.joda.time.Minutes( 2 );

    public static final org.joda.time.Minutes THREE = new org.joda.time.Minutes( 3 );

    public static final org.joda.time.Minutes MAX_VALUE = new org.joda.time.Minutes( Integer.MAX_VALUE );

    public static final org.joda.time.Minutes MIN_VALUE = new org.joda.time.Minutes( Integer.MIN_VALUE );

    private static final org.joda.time.format.PeriodFormatter PARSER = ISOPeriodFormat.standard().withParseType( PeriodType.minutes() );

    private static final long serialVersionUID = 87525275727380863L;

    public static org.joda.time.Minutes minutes( int minutes )
    {
        switch (minutes) {
        case 0 :
            return ZERO;

        case 1 :
            return ONE;

        case 2 :
            return TWO;

        case 3 :
            return THREE;

        case Integer.MAX_VALUE :
            return MAX_VALUE;

        case Integer.MIN_VALUE :
            return MIN_VALUE;

        default  :
            return new org.joda.time.Minutes( minutes );

        }
    }

    public static org.joda.time.Minutes minutesBetween( org.joda.time.ReadableInstant start, org.joda.time.ReadableInstant end )
    {
        int amount = BaseSingleFieldPeriod.between( start, end, DurationFieldType.minutes() );
        return Minutes.minutes( amount );
    }

    public static org.joda.time.Minutes minutesBetween( org.joda.time.ReadablePartial start, org.joda.time.ReadablePartial end )
    {
        if (start instanceof org.joda.time.LocalTime && end instanceof org.joda.time.LocalTime) {
            org.joda.time.Chronology chrono = DateTimeUtils.getChronology( start.getChronology() );
            int minutes = chrono.minutes().getDifference( ((org.joda.time.LocalTime) end).getLocalMillis(), ((org.joda.time.LocalTime) start).getLocalMillis() );
            return Minutes.minutes( minutes );
        }
        int amount = BaseSingleFieldPeriod.between( start, end, ZERO );
        return Minutes.minutes( amount );
    }

    public static org.joda.time.Minutes minutesIn( org.joda.time.ReadableInterval interval )
    {
        if (interval == null) {
            return Minutes.ZERO;
        }
        int amount = BaseSingleFieldPeriod.between( interval.getStart(), interval.getEnd(), DurationFieldType.minutes() );
        return Minutes.minutes( amount );
    }

    public static org.joda.time.Minutes standardMinutesIn( org.joda.time.ReadablePeriod period )
    {
        int amount = BaseSingleFieldPeriod.standardPeriodIn( period, DateTimeConstants.MILLIS_PER_MINUTE );
        return Minutes.minutes( amount );
    }

    public static org.joda.time.Minutes parseMinutes( java.lang.String periodStr )
    {
        if (periodStr == null) {
            return Minutes.ZERO;
        }
        org.joda.time.Period p = PARSER.parsePeriod( periodStr );
        return Minutes.minutes( p.getMinutes() );
    }

    private Minutes( int minutes )
    {
        super( minutes );
    }

    private java.lang.Object readResolve()
    {
        return Minutes.minutes( getValue() );
    }

    public org.joda.time.DurationFieldType getFieldType()
    {
        return DurationFieldType.minutes();
    }

    public org.joda.time.PeriodType getPeriodType()
    {
        return PeriodType.minutes();
    }

    public org.joda.time.Weeks toStandardWeeks()
    {
        return Weeks.weeks( getValue() / DateTimeConstants.MINUTES_PER_WEEK );
    }

    public org.joda.time.Days toStandardDays()
    {
        return Days.days( getValue() / DateTimeConstants.MINUTES_PER_DAY );
    }

    public org.joda.time.Hours toStandardHours()
    {
        return Hours.hours( getValue() / DateTimeConstants.MINUTES_PER_HOUR );
    }

    public org.joda.time.Seconds toStandardSeconds()
    {
        return Seconds.seconds( FieldUtils.safeMultiply( getValue(), DateTimeConstants.SECONDS_PER_MINUTE ) );
    }

    public org.joda.time.Duration toStandardDuration()
    {
        long minutes = getValue();
        return new org.joda.time.Duration( minutes * DateTimeConstants.MILLIS_PER_MINUTE );
    }

    public int getMinutes()
    {
        return getValue();
    }

    public org.joda.time.Minutes plus( int minutes )
    {
        if (minutes == 0) {
            return this;
        }
        return Minutes.minutes( FieldUtils.safeAdd( getValue(), minutes ) );
    }

    public org.joda.time.Minutes plus( org.joda.time.Minutes minutes )
    {
        if (minutes == null) {
            return this;
        }
        return plus( minutes.getValue() );
    }

    public org.joda.time.Minutes minus( int minutes )
    {
        return plus( FieldUtils.safeNegate( minutes ) );
    }

    public org.joda.time.Minutes minus( org.joda.time.Minutes minutes )
    {
        if (minutes == null) {
            return this;
        }
        return minus( minutes.getValue() );
    }

    public org.joda.time.Minutes multipliedBy( int scalar )
    {
        return Minutes.minutes( FieldUtils.safeMultiply( getValue(), scalar ) );
    }

    public org.joda.time.Minutes dividedBy( int divisor )
    {
        if (divisor == 1) {
            return this;
        }
        return Minutes.minutes( getValue() / divisor );
    }

    public org.joda.time.Minutes negated()
    {
        return Minutes.minutes( FieldUtils.safeNegate( getValue() ) );
    }

    public boolean isGreaterThan( org.joda.time.Minutes other )
    {
        if (other == null) {
            return getValue() > 0;
        }
        return getValue() > other.getValue();
    }

    public boolean isLessThan( org.joda.time.Minutes other )
    {
        if (other == null) {
            return getValue() < 0;
        }
        return getValue() < other.getValue();
    }

    public java.lang.String toString()
    {
        return "PT" + String.valueOf( getValue() ) + "M";
    }

}
