// This is mutant program.
// Author : ysma

package org.joda.time;


import org.joda.time.base.BaseSingleFieldPeriod;
import org.joda.time.field.FieldUtils;
import org.joda.time.format.ISOPeriodFormat;
import org.joda.time.format.PeriodFormatter;


public final class Seconds extends org.joda.time.base.BaseSingleFieldPeriod
{

    public static final org.joda.time.Seconds ZERO = new org.joda.time.Seconds( 0 );

    public static final org.joda.time.Seconds ONE = new org.joda.time.Seconds( 1 );

    public static final org.joda.time.Seconds TWO = new org.joda.time.Seconds( 2 );

    public static final org.joda.time.Seconds THREE = new org.joda.time.Seconds( 3 );

    public static final org.joda.time.Seconds MAX_VALUE = new org.joda.time.Seconds( Integer.MAX_VALUE );

    public static final org.joda.time.Seconds MIN_VALUE = new org.joda.time.Seconds( Integer.MIN_VALUE );

    private static final org.joda.time.format.PeriodFormatter PARSER = ISOPeriodFormat.standard().withParseType( PeriodType.seconds() );

    private static final long serialVersionUID = 87525275727380862L;

    public static org.joda.time.Seconds seconds( int seconds )
    {
        switch (seconds) {
        case 0 :
            return ZERO;

        case 1 :
            return ONE;

        case 2 :
            return TWO;

        case 3 :
            return THREE;

        case Integer.MAX_VALUE :
            return MAX_VALUE;

        case Integer.MIN_VALUE :
            return MIN_VALUE;

        default  :
            return new org.joda.time.Seconds( seconds );

        }
    }

    public static org.joda.time.Seconds secondsBetween( org.joda.time.ReadableInstant start, org.joda.time.ReadableInstant end )
    {
        int amount = BaseSingleFieldPeriod.between( start, end, DurationFieldType.seconds() );
        return Seconds.seconds( amount );
    }

    public static org.joda.time.Seconds secondsBetween( org.joda.time.ReadablePartial start, org.joda.time.ReadablePartial end )
    {
        if (start instanceof org.joda.time.LocalTime && end instanceof org.joda.time.LocalTime) {
            org.joda.time.Chronology chrono = DateTimeUtils.getChronology( start.getChronology() );
            int seconds = chrono.seconds().getDifference( ((org.joda.time.LocalTime) end).getLocalMillis(), ((org.joda.time.LocalTime) start).getLocalMillis() );
            return Seconds.seconds( seconds );
        }
        int amount = BaseSingleFieldPeriod.between( start, end, ZERO );
        return Seconds.seconds( amount );
    }

    public static org.joda.time.Seconds secondsIn( org.joda.time.ReadableInterval interval )
    {
        if (interval == null) {
            return Seconds.ZERO;
        }
        int amount = BaseSingleFieldPeriod.between( interval.getStart(), interval.getEnd(), DurationFieldType.seconds() );
        return Seconds.seconds( amount );
    }

    public static org.joda.time.Seconds standardSecondsIn( org.joda.time.ReadablePeriod period )
    {
        int amount = BaseSingleFieldPeriod.standardPeriodIn( period, DateTimeConstants.MILLIS_PER_SECOND );
        return Seconds.seconds( amount );
    }

    public static org.joda.time.Seconds parseSeconds( java.lang.String periodStr )
    {
        if (periodStr == null) {
            return Seconds.ZERO;
        }
        org.joda.time.Period p = PARSER.parsePeriod( periodStr );
        return Seconds.seconds( p.getSeconds() );
    }

    private Seconds( int seconds )
    {
        super( seconds );
    }

    private java.lang.Object readResolve()
    {
        return Seconds.seconds( getValue() );
    }

    public org.joda.time.DurationFieldType getFieldType()
    {
        return DurationFieldType.seconds();
    }

    public org.joda.time.PeriodType getPeriodType()
    {
        return PeriodType.seconds();
    }

    public org.joda.time.Weeks toStandardWeeks()
    {
        return Weeks.weeks( getValue() / DateTimeConstants.SECONDS_PER_WEEK );
    }

    public org.joda.time.Days toStandardDays()
    {
        return Days.days( getValue() / DateTimeConstants.SECONDS_PER_DAY );
    }

    public org.joda.time.Hours toStandardHours()
    {
        return Hours.hours( getValue() / DateTimeConstants.SECONDS_PER_HOUR );
    }

    public org.joda.time.Minutes toStandardMinutes()
    {
        return Minutes.minutes( getValue() / DateTimeConstants.SECONDS_PER_MINUTE );
    }

    public org.joda.time.Duration toStandardDuration()
    {
        long seconds = getValue();
        return new org.joda.time.Duration( seconds * DateTimeConstants.MILLIS_PER_SECOND );
    }

    public int getSeconds()
    {
        return getValue();
    }

    public org.joda.time.Seconds plus( int seconds )
    {
        if (seconds == 0) {
            return this;
        }
        return Seconds.seconds( FieldUtils.safeAdd( getValue(), seconds ) );
    }

    public org.joda.time.Seconds plus( org.joda.time.Seconds seconds )
    {
        if (seconds == null) {
            return this;
        }
        return plus( seconds.getValue() );
    }

    public org.joda.time.Seconds minus( int seconds )
    {
        return plus( FieldUtils.safeNegate( seconds ) );
    }

    public org.joda.time.Seconds minus( org.joda.time.Seconds seconds )
    {
        if (seconds == null) {
            return this;
        }
        return minus( seconds.getValue() );
    }

    public org.joda.time.Seconds multipliedBy( int scalar )
    {
        return Seconds.seconds( FieldUtils.safeMultiply( getValue(), scalar ) );
    }

    public org.joda.time.Seconds dividedBy( int divisor )
    {
        if (divisor == 1) {
            return this;
        }
        return Seconds.seconds( getValue() / divisor );
    }

    public org.joda.time.Seconds negated()
    {
        return Seconds.seconds( FieldUtils.safeNegate( getValue() ) );
    }

    public boolean isGreaterThan( org.joda.time.Seconds other )
    {
        if (other == null) {
            return getValue() > 0;
        }
        return getValue() > other.getValue();
    }

    public boolean isLessThan( org.joda.time.Seconds other )
    {
        if (other == null) {
            return getValue() < 0;
        }
        return getValue() < other.getValue();
    }

    public java.lang.String toString()
    {
        return "PT" + String.valueOf( getValue() ) + "S";
    }

}
